#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;
uniform float sampleNum;

vec3 blur(vec2);

void main(void)
{
    vec3 col = blur(v_texCoord);
    gl_FragColor = vec4(col, 1.0) * v_fragmentColor;
}

vec3 blur(vec2 p)
{
    if (blurRadius > 0.0 && sampleNum > 1.0)
    {
        vec3 col = vec3(0);
        vec2 unit = 1.0 / resolution.xy;

        float count = 0.0;
        
        float xx = 0.0;
        float yy = 0.0;

        float weight = 0.0;

        for(int x = -3; x < 3; x += 1)
        {
            for(int y = -3; y < 3; y += 1)
            {
		xx = float(x);
		yy = float(y);
                weight = (4.0 - abs(xx)) * (4.0 - abs(yy));
                col += texture2D(CC_Texture0, p + vec2(xx * unit.x, yy * unit.y)).rgb * weight;
                count += weight;
            }
        }
        
        return col / count;
    }
    
    return texture2D(CC_Texture0, p).rgb;
}
